//---------------------------------------------------------------------------

#include <vcl.h>
#include <StdCtrls.hpp>

#pragma hdrstop

#include "Logger.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)

//---------------------------------------------------------------------------
TRichEdit* TLogger::myMemo = NULL;


void TLogger::clearLog(){
  if(!myMemo) return;
  myMemo->Clear();
//  myMemo->DefAttributes->Color = clBlack;
//  myMemo->DefAttributes->Style.Clear();
}

void TLogger::logHeader(AnsiString header, bool clear){
  if(!myMemo) return;
  
  if(clear)clearLog();

  myMemo->SelAttributes->Color = clBlue;
//  myMemo->SelAttributes->Style =
    myMemo->SelAttributes->Style << fsBold;
  myMemo->Lines->Add(AnsiString("-= ")+header+" ==============");
}

//---------------------------------------------------------------------------
void TLogger::log(AnsiString msg){
  log(msg, 0);
}

//---------------------------------------------------------------------------
void TLogger::message(AnsiString msg){
  log(msg, 1);
}

//---------------------------------------------------------------------------
void TLogger::error(AnsiString msg){
  log(msg, -1);
}

//---------------------------------------------------------------------------
void TLogger::log(AnsiString msg, int msgType){
  if(!myMemo) return;

  myMemo->SelAttributes->Color = (msgType >= 0) ? clBlack : clRed;
  if(msgType == 0){
    myMemo->SelAttributes->Style >> fsBold;
  }else{
    myMemo->SelAttributes->Style = myMemo->SelAttributes->Style << fsBold;
  }

  myMemo->Lines->Add(msg);
}
