//---------------------------------------------------------------------------

#ifndef SelectImageUnitH
#define SelectImageUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include <ExtCtrls.hpp>
#include <Dialogs.hpp>
//---------------------------------------------------------------------------
class TSelectFontImageForm : public TForm
{
__published:	// IDE-managed Components
  TPanel *Panel1;
  TScrollBox *ScrollBox1;
  TPaintBox *FontPaintBox;
  TFontDialog *FontDialog1;
  TButton *NoFontButton;
  TSpeedButton *AddFontBtn;
  TSpeedButton *RemoveFontButton;
  TBitBtn *_SubmitBtn;
  void __fastcall ScrollBox1Resize(TObject *Sender);
  void __fastcall FontPaintBoxPaint(TObject *Sender);
  void __fastcall NoFontButtonClick(TObject *Sender);
  void __fastcall FormCreate(TObject *Sender);
  void __fastcall FontPaintBoxMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
  void __fastcall FontPaintBoxDblClick(TObject *Sender);
  void __fastcall FormShortCut(TWMKey &Msg, bool &Handled);
  void __fastcall FontPaintBoxMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
  void __fastcall AddFontBtnClick(TObject *Sender);
  void __fastcall RemoveFontButtonClick(TObject *Sender);
private:	// User declarations
///////////////////////////////////////////////

  AnsiString myDir;

//  AnsiString myCurSelectedFontName;
  TStringList* myFontImages;
  TStringList* myFontNames;
  TRect* myFontImgBounds;
  int mySelectedImageIndex;

  void drawFont(int fontIndex);

  static Graphics::TBitmap* createFontImage(TFont* font, Graphics::TBitmap* useIfProvided = NULL);
  void saveSelectedFont(TFont* font);
  void refreshFonts();
  void scrollToFont(int index);
  void __fastcall SetSelectedImagePath(AnsiString value);
  AnsiString __fastcall GetSelectedImagePath();
  Graphics::TBitmap* __fastcall GetSelectedImage();
  void __fastcall SetSelectedIndex(int value);
  int __fastcall GetSelectedIndex();
  void __fastcall SetDirectory(AnsiString value);
  AnsiString __fastcall GetDirectory();

public:		// User declarations
  __fastcall TSelectFontImageForm(TComponent* Owner);

  //Graphics::TBitmap* selectFontImage(AnsiString dir);
  bool selectImage();
  __property AnsiString SelectedImagePath  = { read=GetSelectedImagePath, write=SetSelectedImagePath };
  __property Graphics::TBitmap* SelectedImage  = { read=GetSelectedImage};
  __property int SelectedIndex  = { read=GetSelectedIndex, write=SetSelectedIndex };
  __property AnsiString Directory  = { read=GetDirectory, write=SetDirectory };
};
//---------------------------------------------------------------------------
extern PACKAGE TSelectFontImageForm *SelectFontImageForm;
//---------------------------------------------------------------------------
#endif
