//---------------------------------------------------------------------------

#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <ComCtrls.hpp>
#include <Buttons.hpp>

#include "Packer.h"
#include <Grids.hpp>
#include <Dialogs.hpp>
#include "ZipBuilder.h"
#include <ToolWin.hpp>
#include <ImgList.hpp>
#include <Graphics.hpp>

//---------------------------------------------------------------------------
class TShellForm : public TForm
{
__published:	// IDE-managed Components
        TPanel *Panel1;
        TPageControl *PageControl1;
        TTabSheet *TabSheet1;
        TTabSheet *TabSheet3;
        TBitBtn *BitBtn1;
  TStringGrid *textFileList;
  TOpenDialog *textFileOpenDialog;
  TZipBuilder *myZipBuilder;
  TImageList *ImageList1;
  TToolBar *ToolBar1;
  TToolButton *myTBAddTxt;
  TToolButton *myTBRemoveTxt;
  TToolButton *ToolButton3;
  TToolButton *myTBRenameTxt;
  TToolButton *myTBEditTxt;
  TEdit *projectName;
  TLabel *myTargetDirLabel;
  TLabel *_Label6;
  TTabSheet *aboutTabSheet;
  TMemo *Memo1;
  TImage *Image1;
  TBitBtn *buildButton;
  TColorDialog *ColorDialog1;
  TToolBar *ToolBar2;
  TButton *_myBrowseTargetDirBtn;
  TTabSheet *myLogTabSheet;
  TRichEdit *myLogText;
  TButton *myClearLogButton;
  TCheckBox *myCBShowZipDebug;
  TToolButton *SelFGColorBtn;
  TToolButton *SelBGColorBtn;
  TPaintBox *FontImagePaintBox;
  TToolButton *InvertFontButton;
  TToolButton *ToolButton1;
  TBitBtn *SelRotatedFontTButton;
  TBitBtn *SelNormalFontTButton;
  TLabel *EncodingLabel;
  TComboBox *EncodingComboBox;
  TLabel *MidletTypeLabel;
  TComboBox *MidletTypeCombo;
  TCheckBox *HasDirButtonsCheckBox;
  TCheckBox *ExtendHeightCheckBox;
  TEdit *ExtendHeightEdit;
  TEdit *myMaxBookSize;
  TEdit *myMaxSuiteTextSize;
  TCheckBox *DivideChaptersCheckBox;
  TEdit *myChapterDividePatterns;
  TCheckBox *AltDirButtonsCheckBox;
  TCheckBox *UseSeT610SideKeysCheckBox;
  TCheckBox *RestrictChapterCheckBox;
  TCheckBox *RestrictJarCheckBox;
  TLabel *LocalizationAuthorNameLabel;
  TCheckBox *LocalizeMidletCheckBox;
  void __fastcall buildButtonClick(TObject *Sender);
  void __fastcall FormCreate(TObject *Sender);
  void __fastcall FormDestroy(TObject *Sender);
  void __fastcall FormResize(TObject *Sender);
  void __fastcall textFileListDblClick(TObject *Sender);
  void __fastcall myTBAddTxtClick(TObject *Sender);
  void __fastcall myTBRenameTxtClick(TObject *Sender);
  void __fastcall myTBEditTxtClick(TObject *Sender);
  void __fastcall myTBRemoveTxtClick(TObject *Sender);
  void __fastcall myTargetDirLabelClick(TObject *Sender);
  void __fastcall textFileListKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
  void __fastcall _myBrowseTargetDirBtnClick(TObject *Sender);
  void __fastcall myTargetDirLabelMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
  void __fastcall myZipBuilderMessage(TObject *Sender, int ErrCode,
          AnsiString Message);
  void __fastcall myClearLogButtonClick(TObject *Sender);
  void __fastcall SelFGColorBtnClick(TObject *Sender);
  void __fastcall SelBGColorBtnClick(TObject *Sender);
  void __fastcall FontImagePaintBoxPaint(TObject *Sender);
  void __fastcall SelectNormalFontBtnClick(TObject *Sender);
  void __fastcall SelectRotatedFontBtnClick(TObject *Sender);
  void __fastcall MidletTypeComboSelect(TObject *Sender);
  void __fastcall PageControl1Resize(TObject *Sender);
  void __fastcall InvertFontButtonClick(TObject *Sender);
  void __fastcall DivideChaptersCheckBoxClick(TObject *Sender);
  void __fastcall ExtendHeightCheckBoxClick(TObject *Sender);
  void __fastcall RestrictChapterCheckBoxClick(TObject *Sender);
  void __fastcall RestrictJarCheckBoxClick(TObject *Sender);
  void __fastcall Image1DblClick(TObject *Sender);

private:
// ****************************** User declarations

  Packer* myPacker;
  AnsiString myOutputDir;

  Graphics::TBitmap *myNormalFontImage, *myRotatedFontImage;
  AnsiString myNormalFontPath, myRotatedFontPath;
  TColor myFgColor, myBgColor;

  void updateList();
  void renameText();
  void removeText();
  void addText();
  void shellEditText();
  void setFontImage(Graphics::TBitmap* bmp, Graphics::TBitmap* fromImage);
  void selectColor(TColor& color);
  void setImageColors(Graphics::TBitmap* bmp);
  void readEncodings(AnsiString defaultEncodingName);
  AnsiString checkLocalizationAvailable();

public:
        __fastcall TShellForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TShellForm *ShellForm;
//---------------------------------------------------------------------------
#endif
 