//---------------------------------------------------------------------------

#define NO_WIN32_LEAN_AND_MEAN
#include <shlobj.hpp>
//#include <SHELLAPI.H>

#include <vcl.h>

#include <sys\stat.h>

#pragma hdrstop

#include "FreeImage.h"
#include "Utils.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)


//---------------------------------------------------------------------------
/*
FIBITMAP *Utils::makeTransparent(FIBITMAP *src){
  FIBITMAP *hDIB24bpp = FreeImage_ConvertTo24Bits(src); // FreeImage_Load (FIF_BMP, "test.bmp", 0);
  FIBITMAP *hDIB8bpp = FreeImage_ColorQuantize(hDIB24bpp, FIQ_WUQUANT);
  // get palette and find bright green (quantize maps 0xff -> 0xfe (?)
  RGBQUAD *Palette = FreeImage_GetPalette(hDIB8bpp);
  BYTE Transparency[256];

  for (unsigned i = 0; i < 256; i++) {
  Transparency[i] = 0xFF;
  if (Palette[i].rgbGreen == 0xff &&
  Palette[i].rgbBlue == 0xff &&
  Palette[i].rgbRed == 0xff) {
    Transparency[i] = 0x00;
  }
  }
  // set the tranparency table
  FreeImage_SetTransparencyTable(hDIB8bpp, Transparency, 256);
  return hDIB8bpp;
//  return FreeImage_Threshold(hDIB8bpp, 1);
}
*/


void Utils::showContextPopupMenu(AnsiString theFullPath, HWND parentWindow, TPoint coord, bool showExtendedMenu){
  AnsiString fileName = ExtractFileName(theFullPath);
  AnsiString fileParentFolderPath = ExtractFileDir(theFullPath);

  LPSHELLFOLDER DesktopFolder;
  if(NOERROR != SHGetDesktopFolder(&DesktopFolder)){
    return;
  }

  wchar_t wPath[MAX_PATH];
  LPITEMIDLIST ParentPidl;
  DWORD Eaten;
  StringToWideChar(fileParentFolderPath, wPath, MAX_PATH);
  if(NOERROR != DesktopFolder->ParseDisplayName(parentWindow, 0, wPath, &Eaten, &ParentPidl, 0)){
    return;
  }

  LPSHELLFOLDER ParentFolder;
  if(NOERROR != DesktopFolder->BindToObject(ParentPidl, 0, IID_IShellFolder,(void**)&ParentFolder)){
    return;
  }

  LPITEMIDLIST Pidl;
  StringToWideChar(fileName, wPath, MAX_PATH);
  if(NOERROR!=ParentFolder->ParseDisplayName(parentWindow, 0, wPath, &Eaten, &Pidl, 0)){
    return;
  }

  LPCONTEXTMENU CM;
  if(NOERROR!= ParentFolder->GetUIObjectOf(parentWindow, 1, (LPCITEMIDLIST*)&Pidl, IID_IContextMenu, 0, (void**)&CM)){
    return;
  }

  HMENU hMenu = CreatePopupMenu();
  //DWORD Flags = CMF_EXPLORE |
  DWORD Flags = CMF_NORMAL	;
  if(showExtendedMenu)
    Flags |= 0x00000080;
  CM->QueryContextMenu(hMenu, 0, 1, 0x7FFF, Flags);

  TPoint pt;
  GetCursorPos(&pt);
  int cmd = TrackPopupMenu(hMenu,
    TPM_LEFTALIGN | TPM_LEFTBUTTON | TPM_RIGHTBUTTON | TPM_RETURNCMD,
    pt.x, pt.y, 0, parentWindow, 0);


  CMINVOKECOMMANDINFO CI;
  ZeroMemory(&CI, sizeof(CI));
  CI.cbSize = sizeof(CMINVOKECOMMANDINFO);
  CI.hwnd = parentWindow;

  if (cmd) {
    CI.lpVerb = MAKEINTRESOURCE(cmd - 1);
    CI.lpParameters = "";
    CI.lpDirectory = "";
    CI.nShow = SW_SHOWNORMAL;
    CM->InvokeCommand(&CI);
  }
  //ShowMessage(AnsiString("Show Popup: ")+cmd);
}

int Utils::getFileSize(AnsiString path){
  //TODO: Add your source code here
  struct stat statbuf;
  ::stat(path.c_str(), &statbuf);
  return statbuf.st_size;
}

